package com.ruoyi.web.v1.service;

import java.util.Date;
import java.util.List;

import cn.hutool.core.date.DateTime;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.web.v1.model.EntranceBatch;
import com.ruoyi.web.v1.model.request.ReqEntranceBatchList;
import com.ruoyi.web.v1.model.response.ValidEntrance;

/**
 * 入场批次Service接口
 * 
 * @author coede
 * @date 2025-03-19
 */
public interface IEntranceBatchService 
{
    /**
     * 查询入场批次
     * 
     * @param id 入场批次主键
     * @return 入场批次
     */
    public EntranceBatch selectEntranceBatchById(Long id);

    /**
     * 查询入场批次列表
     * 
     * @param req 入场批次
     * @return 入场批次集合
     */
    public List<EntranceBatch> selectEntranceBatchList(ReqEntranceBatchList req);


    public List<EntranceBatch> selectEntranceBatchList1(EntranceBatch entranceBatch);

    /**
     * 完工报告逻辑修正
     */
    public List<EntranceBatch> selectEntranceBatchList2(EntranceBatch entranceBatch);

    /**
     * 校验检疫证号是否唯一
     *
     * @param entranceBatch 入场批次
     * @return 结果
     */
    public boolean checkAnimalCertNoUnique(EntranceBatch entranceBatch);

    /**
     * 新增入场批次
     * 
     * @param entranceBatch 入场批次
     * @return 结果
     */
    public Long insertEntranceBatch(EntranceBatch entranceBatch);

    /**
     * 修改入场批次
     * 
     * @param entranceBatch 入场批次
     * @return 结果
     */
    public int updateEntranceBatch(EntranceBatch entranceBatch);

    /**
     * 批量删除入场批次
     * 
     * @param ids 需要删除的入场批次主键集合
     * @return 结果
     */
    public int deleteEntranceBatchByIds(Long[] ids);

    /**
     * 删除入场批次信息
     * 
     * @param id 入场批次主键
     * @return 结果
     */
    public int deleteEntranceBatchById(Long id);

    /**
     * 获取最近一条记录
     * @return 结果
     */
    public EntranceBatch selectLatelyEntrance();

    //获取所有可用批次
    public List<ValidEntrance> getAllValidEntrance();

    Integer getOne( Date dateTime);

    List<EntranceBatch> listAll();

}
